#ifndef	_KAMOD_PCA9533_H
#define	_KAMOD_PCA9533_H
#include <stdint.h>
#include "kamod_common.h"

#define PCA9533_ADDR						0x62

//Control register address
#define PCA9533_CTRL_REG_INPUT	0x00
#define PCA9533_CTRL_REG_PSC0		0x01
#define PCA9533_CTRL_REG_PWM0		0x02
#define PCA9533_CTRL_REG_PSC1		0x03
#define PCA9533_CTRL_REG_PWM1		0x04
#define PCA9533_CTRL_REG_LS0		0x05

//LED blinking modes
#define PCA9533_MODE_OFF				0x00
#define PCA9533_MODE_ON					0x01
#define PCA9533_MODE_PWM0				0x02
#define PCA9533_MODE_PWM1				0x03

//LED color definitions
#define PCA9533_LED_GREEN				0x00
#define PCA9533_LED_RED					0x01
#define PCA9533_LED_BLUE				0x02

int32_t pca9533_init();

void pca9533_set_psc_pwm0(uint8_t prescaler);
void pca9533_set_freq_pwm0(uint32_t frequency);
void pca9533_set_duty_pwm0(uint8_t duty);

void pca9533_set_psc_pwm1(uint8_t prescaler);
void pca9533_set_freq_pwm1(uint32_t frequency);
void pca9533_set_duty_pwm1(uint8_t duty);

void pca9533_set_pwm0(uint32_t frequency, uint8_t brightness);
void pca9533_set_pwm1(uint32_t frequency, uint8_t brightness);
int32_t pca9533_set_led(uint8_t led, uint8_t mode);

#endif
